<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>gateway documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">gateway documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content injectable">
                   <div class="content-data">







<ol class="breadcrumb">
  <li>Injectables</li>
  <li>UserSagas</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/services/users/sagas/users.saga.ts</code>
        </p>




            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                    <span class="modifier">Readonly</span>
                                <a href="#logger">logger</a>
                            </li>
                            <li>
                                <a href="#userCreated">userCreated</a>
                            </li>
                        </ul>
                    </td>
                </tr>






        </tbody>
    </table>
</section>



            <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="logger"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                                <span class="modifier">Readonly</span>
                            logger</b>
                            <a href="#logger"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>new Logger(UserSagas.name)</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="12" class="link-to-prism">src/services/users/sagas/users.saga.ts:12</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="userCreated"></a>
                        <span class="name">
                            <b>
                            userCreated</b>
                            <a href="#userCreated"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>() &#x3D;&gt; {...}</code>
                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <b>Decorators : </b>
                            <br />
                            <code>
                                @Saga()<br />
                            </code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="39" class="link-to-prism">src/services/users/sagas/users.saga.ts:39</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Injectable, Logger } from &quot;@nestjs/common&quot;
import { Saga, ICommand, ofType } from &quot;@nestjs/cqrs&quot;
import { Observable } from &quot;rxjs&quot;
import { map, delay, mergeMap } from &#x27;rxjs/operators&#x27;
import { CreateUserEvent } from &quot;../events/users.aggregate&quot;
// import { CreatePlayerCommand } from &quot;../players/players.commands&quot;
import { CreateUserCommand, AddSocialAccountToUserCommand } from &quot;../commands/users.commands&quot;

@Injectable()
export class UserSagas {

    private readonly logger &#x3D; new Logger(UserSagas.name)

    // @Saga()
    // kappaAttack &#x3D; (events$: Observable&lt;any&gt;): Observable&lt;ICommand&gt; &#x3D;&gt; {
    //     return events$.pipe(
    //         ofType(AttackEvent),
    //         map((event: any) &#x3D;&gt; new ConsumeStaminaEvent()),
    //     )
    // }

    // @Saga()
    // attack &#x3D; (events$: Observable&lt;any&gt;): Observable&lt;ICommand&gt; &#x3D;&gt; {
    //     return events$
    //         .pipe(
    //             ofType(AttackEvent),
    //             // delay(1000),
    //             map(event &#x3D;&gt; {
    //                 this.logger.debug(&#x27;Saga attack func&#x27;)
    //                 // return new DropAncientItemCommand(event.heroId, itemId);
    //                 // return new ConsumeStaminaEvent()
    //                 // return new AttackEvent
    //                 return new AttackCommand
    //             }),
    //         )
    // }

    @Saga()
    userCreated &#x3D; (events$: Observable&lt;any&gt;): Observable&lt;ICommand&gt; &#x3D;&gt; {
        return events$
            .pipe(
                ofType(CreateUserEvent),
                // delay(1000),
                map(event &#x3D;&gt; {
                    this.logger.debug(&#x27;Saga usercreated event func&#x27;)
                    // this.logger.debug(events$)
                    // this.logger.debug(event)
                    const user_fire_id &#x3D; event.user_fire_id
                    const user_mongo_id &#x3D; event.user_mongo_id
                    const username &#x3D; event.username
                    const password &#x3D; event.password
                    const email &#x3D; event.email
                    const account &#x3D; event.account
                    const first_name &#x3D; event.first_name
                    const last_name &#x3D; event.last_name
                    const avatar &#x3D; event.avatar
                    const avatar_url &#x3D; event.avatar_url
                    const private_account &#x3D; event.private_account
                    const use_real_name &#x3D; event.use_real_name

                    const commands: ICommand[] &#x3D; [
                        new CreateUserCommand(
                            user_fire_id,
                            user_mongo_id,
                            username,
                            password,
                            email,
                            account,
                            first_name,
                            last_name,
                            avatar,
                            avatar_url,
                            private_account,
                            use_real_name
                        ),
                        // new AddSocialAccountToUserCommand(user_id, access_token),
                    ]

                    return commands
                }),
                mergeMap(f &#x3D;&gt; f),
            )
    }
}</code></pre>
    </div>

</div>







                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'injectable';
            var COMPODOC_CURRENT_PAGE_URL = 'UserSagas.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
